
//
//  Bench.c - Memory Alignment Test
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 2 Jun 98 - James Leiterman
//
//  Last Modification
//
//      23 Jul 2001 - JCL - Brought up to date.
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries

#include <stdlib.h>
#include <stdio.h>
#include <string.h>



#define RAM_TBL_SIZE        4096



int main( int argc, char *argv[] )
{
    unsigned int n, nCnt, bSet, bTst, bMsk, a, b;
    byte *pTbl[ RAM_TBL_SIZE ];

        //  Allocate a series of increasingly different size blocks of memory

    for ( n = 0; n < RAM_TBL_SIZE; n++ )
      {
        if ( NULL == ( pTbl[n] = (byte *) malloc( n+1 )) )
          {
            printf( "low memory.  (continuing...)\n" );
            break;
          }
      }

    nCnt = n;                           // # of entries allocated
    
        //  Test memory for alignments

    bSet = 16;                          // Preset to 128bit (128/8)
    bTst = bSet - 1;
    bMsk = ~0 ^ bTst; 

    for ( n = 0; n < nCnt; n++ )
      {
        a = (unsigned int) pTbl[n];

        do {
            b = ( a + bTst ) & bMsk;    // round up to 'bSet' bits

            if ( a == b )
              {
                break;                  // okay
              }
                                        // Unaligned...
            bSet >>= 1;                 // reduce by a bit
            bTst = bSet - 1;
            bMsk = ~0 ^ bTst; 
          } while(1);
      }

        //  Release all of memory to cleanup

    for ( n = 0; n < nCnt; n++ )
      {
          free( pTbl[n] );
          pTbl[n] = NULL;
      }

    printf( "\nRam Alignment is set to %u bytes (%u bits).\n\n",
        bSet, (bSet<<3) );
    printf( "Fin!\n\n" );

    return 0;
}

