
//
//  CpuMIPS.cpp (CPU MIPS)
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 14 Nov 2001 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//

#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include <string.h>
#include <stdio.h>
#include <assert.h>

    //  Book Development Library Modules

#include "CpuAsm.h"




//
//  CPU Vendor Lookup Table
//

static char *CpuVendor[] =
{
    "UNKNOWN MFG",
    "TOSHIBA",          // CPUVEN_TOSHIBA     = 1
};




void CpuDetect( CpuInfo * const pInfo )
{
    ASSERT_PTR4( pInfo );
    
    memset(pInfo, 0, sizeof(CpuInfo));

    pInfo->nMfg = CPUVEN_TOSHIBA;
    pInfo->nBits = CPUBITS_EE | CPUBITS_VU0 | CPUBITS_VU1;
}



//
// CPU information string
//

char *CpuInfoStr( char *pBuf, const CpuInfo * const pInfo )
{
    char *p;
    
    ASSERT_PTR(pBuf);
    ASSERT_PTR(pInfo);

    p = pBuf + sprintf( pBuf, "MIPS '%s' ", CpuVendor[pInfo->nMfg ] );
     
    if ( CPUBITS_EE & pInfo->nBits )
      {
        p += sprintf( p, " MMI" );
      }

    sprintf( p, "\n" );
    
    return pBuf;
}
