  
//
//  PBool.h - Packed Boolean Logic
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 26 Jan, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions


#ifndef __PBool_H
#define __PBool_H

#ifdef __cplusplus
extern "C" {
#endif


typedef void (*vmp_pnotProc)(  void * const pvD, const void * const pvA );
extern vmp_pnotProc vmp_pnot;
extern vmp_pnotProc vmp_pnot0;

typedef void (*vmp_pandProc)(  void * const pvD, const void * const pvA, const void * const pvB );
extern vmp_pandProc vmp_pand;
extern vmp_pandProc vmp_pand0;

typedef void (*vmp_pandcProc)( void * const pvD, const void * const pvA, const void * const pvB );
extern vmp_pandcProc vmp_pandc;
extern vmp_pandcProc vmp_pandc0;

typedef void (*vmp_porProc)(   void * const pvD, const void * const pvA, const void * const pvB );
extern vmp_porProc vmp_por;
extern vmp_porProc vmp_por0;

typedef void (*vmp_pxorProc)(  void * const pvD, const void * const pvA, const void * const pvB );
extern vmp_pxorProc vmp_pxor;
extern vmp_pxorProc vmp_pxor0;

typedef void (*vmp_pnorProc)(  void * const pvD, const void * const pvA, const void * const pvB );
extern vmp_pnorProc vmp_pnor;
extern vmp_pnorProc vmp_pnor0;



#ifdef __cplusplus
}
#endif

#endif  //__PBool_H


