
//
//  PBoolEx.h - Packed Boolean Logic
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 26 Jan, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PBoolEx_H
#define __PBoolEx_H

#ifdef __cplusplus
extern "C" {
#endif



void PBoolSetup( const CpuInfo * const pcinfo );


void vmp_pnotGeneric(  void * const pvD, const void * const pvA );
void vmp_pnotMMI(    void * const pvD, const void * const pvA );
void vmp_pnotMMI0(   void * const pvD, const void * const pvA );

void vmp_pandGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandMMI(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandMMI0(   void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pandcGeneric( void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcMMI(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcMMI0(  void * const pvD, const void * const pvA, const void * const pvB );

void vmp_porGeneric(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porMMI(     void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porMMI0(    void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pxorGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorMMI(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorMMI0(   void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pnorGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorMMI(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorMMI0(   void * const pvD, const void * const pvA, const void * const pvB );



#ifdef __cplusplus
}
#endif

#endif  //__PBoolEx_H





