
//
//  PBoolMIPS.c - Packed Boolean Logic
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 26 Jan, 2002 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <stdio.h>

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "vmp3D.h"
#include "vmp3DEx.h"
#include "PBool.h"
#include "PBoolEx.h"



//
//  Setup Packed Boolean Logic
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void PBoolSetup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR4(pcinfo);
        
    vmp_pand =              vmp_pandMMI;
    vmp_pand0 =             vmp_pandMMI0;
    vmp_pandc =             vmp_pandcMMI;
    vmp_pandc0 =            vmp_pandcMMI0;
    vmp_por =               vmp_porMMI;
    vmp_por0 =              vmp_porMMI0;
    vmp_pxor =              vmp_pxorMMI;
    vmp_pxor0 =             vmp_pxorMMI0;
    vmp_pnor =              vmp_pnorMMI;
    vmp_pnor0 =             vmp_pnorMMI0;
    vmp_pnot =              vmp_pnotMMI;
    vmp_pnot0 =             vmp_pnotMMI0;
}




