  
//
//  PRot.h - Packed Rotation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions


#ifndef __PRot_H
#define __PRot_H

#ifdef __cplusplus
extern "C" {
#endif


    //  Shift Right Arithmetic by count

typedef void (*vmp_psraBProc)( int8  * const pbD, const int8  * const pbA, uint count );
extern vmp_psraBProc vmp_psraB;
extern vmp_psraBProc vmp_psraB0;

typedef void (*vmp_psraHProc)( int16 * const phD, const int16 * const phA, uint count );
extern vmp_psraHProc vmp_psraH;
extern vmp_psraHProc vmp_psraH0;

typedef void (*vmp_psraWProc)( int32 * const pwD, const int32 * const pwA, uint count );
extern vmp_psraWProc vmp_psraW;
extern vmp_psraWProc vmp_psraW0;

    //  Shift Right Arithmetic by 1

typedef void (*vmp_psra1BProc)( int8  * const pbD, const int8  * const pbA );
extern vmp_psra1BProc vmp_psra1B;
extern vmp_psra1BProc vmp_psra1B0;

typedef void (*vmp_psra1HProc)( int16 * const phD, const int16 * const phA );
extern vmp_psra1HProc vmp_psra1H;
extern vmp_psra1HProc vmp_psra1H0;

typedef void (*vmp_psra1WProc)( int32 * const pwD, const int32 * const pwA );
extern vmp_psra1WProc vmp_psra1W;
extern vmp_psra1WProc vmp_psra1W0;

    //  Shift Left Logical by Count

typedef void (*vmp_psllBProc)( uint8  * const pbD, const uint8  * const pbA, uint count );
extern vmp_psllBProc vmp_psllB;
extern vmp_psllBProc vmp_psllB0;

typedef void (*vmp_psllHProc)( uint16 * const phD, const uint16 * const phA, uint count );
extern vmp_psllHProc vmp_psllH;
extern vmp_psllHProc vmp_psllH0;

typedef void (*vmp_psllWProc)( uint32 * const pwD, const uint32 * const pwA, uint count );
extern vmp_psllWProc vmp_psllW;
extern vmp_psllWProc vmp_psllW0;

    //  Shift Left Logical by 1

typedef void (*vmp_psll1BProc)( uint8  * const pbD, const uint8  * const pbA );
extern vmp_psll1BProc vmp_psll1B;
extern vmp_psll1BProc vmp_psll1B0;

typedef void (*vmp_psll1HProc)( uint16 * const phD, const uint16 * const phA );
extern vmp_psll1HProc vmp_psll1H;
extern vmp_psll1HProc vmp_psll1H0;

typedef void (*vmp_psll1WProc)( uint32 * const pwD, const uint32 * const pwA );
extern vmp_psll1WProc vmp_psll1W;
extern vmp_psll1WProc vmp_psll1W0;

    //  Shift Right Logical by count

typedef void (*vmp_psrlBProc)( uint8  * const pbD, const uint8  * const pbA, uint count );
extern vmp_psrlBProc vmp_psrlB;
extern vmp_psrlBProc vmp_psrlB0;

typedef void (*vmp_psrlHProc)( uint16 * const phD, const uint16 * const phA, uint count );
extern vmp_psrlHProc vmp_psrlH;
extern vmp_psrlHProc vmp_psrlH0;

typedef void (*vmp_psrlWProc)( uint32 * const pwD, const uint32 * const pwA, uint count );
extern vmp_psrlWProc vmp_psrlW;
extern vmp_psrlWProc vmp_psrlW0;

    //  Shift Right Logical by 1

typedef void (*vmp_psrl1BProc)( uint8  * const pbD, const uint8  * const pbA );
extern vmp_psrl1BProc vmp_psrl1B;
extern vmp_psrl1BProc vmp_psrl1B0;

typedef void (*vmp_psrl1HProc)( uint16 * const phD, const uint16 * const phA );
extern vmp_psrl1HProc vmp_psrl1H;
extern vmp_psrl1HProc vmp_psrl1H0;

typedef void (*vmp_psrl1WProc)( uint32 * const pwD, const uint32 * const pwA );
extern vmp_psrl1WProc vmp_psrl1W;
extern vmp_psrl1WProc vmp_psrl1W0;

    //  Rotate Left by Count

typedef void (*vmp_prolBProc)( uint8  * const pbD, const uint8  * const pbA, uint count );
extern vmp_prolBProc vmp_prolB;
extern vmp_prolBProc vmp_prolB0;

typedef void (*vmp_prolHProc)( uint16 * const phD, const uint16 * const phA, uint count );
extern vmp_prolHProc vmp_prolH;
extern vmp_prolHProc vmp_prolH0;

typedef void (*vmp_prolWProc)( uint32 * const pwD, const uint32 * const pwA, uint count );
extern vmp_prolWProc vmp_prolW;
extern vmp_prolWProc vmp_prolW0;

    //  Rotate Left by 1

typedef void (*vmp_prol1BProc)( uint8  * const pbD, const uint8  * const pbA );
extern vmp_prol1BProc vmp_prol1B;
extern vmp_prol1BProc vmp_prol1B0;

typedef void (*vmp_prol1HProc)( uint16 * const phD, const uint16 * const phA );
extern vmp_prol1HProc vmp_prol1H;
extern vmp_prol1HProc vmp_prol1H0;

typedef void (*vmp_prol1WProc)( uint32 * const pwD, const uint32 * const pwA );
extern vmp_prol1WProc vmp_prol1W;
extern vmp_prol1WProc vmp_prol1W0;



#ifdef __cplusplus
}
#endif

#endif  //__PRot_H


