
//
//  PRotEx.h - Packed Rotation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 1 Sep, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PRotEx_H
#define __PRotEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PRotSetup( const CpuInfo * const pcinfo );

    //  Shift Right Arithmetic

void vmp_psraBGeneric( int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBMMI(     int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBMMI0(    int8  * const pbD, const int8  * const pbA, uint count );

void vmp_psraHGeneric( int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHMMI(     int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHMMI0(    int16 * const phD, const int16 * const phA, uint count );

void vmp_psraWGeneric( int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWMMI(     int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWMMI0(    int32 * const pwD, const int32 * const pwA, uint count );

void vmp_psra1BGeneric( int8  * const pbD, const int8  * const pbA );
void vmp_psra1BMMI(     int8  * const pbD, const int8  * const pbA );
void vmp_psra1BMMI0(    int8  * const pbD, const int8  * const pbA );

void vmp_psra1HGeneric( int16 * const phD, const int16 * const phA );
void vmp_psra1HMMI(     int16 * const phD, const int16 * const phA );
void vmp_psra1HMMI0(    int16 * const phD, const int16 * const phA );

void vmp_psra1WGeneric( int32 * const pwD, const int32 * const pwA );
void vmp_psra1WMMI(     int32 * const pwD, const int32 * const pwA );
void vmp_psra1WMMI0(    int32 * const pwD, const int32 * const pwA );

    //  Shift Left Logical

void vmp_psllBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBMMI(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBMMI0(    uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psllHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHMMI(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHMMI0(    uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psllWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWMMI(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWMMI0(    uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_psll1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BMMI(     uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BMMI0(    uint8  * const pbD, const uint8  * const pbA );

void vmp_psll1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psll1HMMI(     uint16 * const phD, const uint16 * const phA );
void vmp_psll1HMMI0(    uint16 * const phD, const uint16 * const phA );

void vmp_psll1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WMMI(     uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WMMI0(    uint32 * const pwD, const uint32 * const pwA );

    //  Shift Right Logical

void vmp_psrlBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBMMI(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBMMI0(    uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psrlHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHMMI(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHMMI0(    uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psrlWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWMMI(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWMMI0(    uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_psrl1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BMMI(     uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BMMI0(    uint8  * const pbD, const uint8  * const pbA );

void vmp_psrl1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HMMI(     uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HMMI0(    uint16 * const phD, const uint16 * const phA );

void vmp_psrl1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WMMI(     uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WMMI0(    uint32 * const pwD, const uint32 * const pwA );

    //  Rotate Left

void vmp_prolBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBMMI(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBMMI0(    uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_prolHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHMMI(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHMMI0(    uint16 * const phD, const uint16 * const phA, uint count );

void vmp_prolWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWMMI(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWMMI0(    uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_prol1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BMMI(     uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BMMI0(    uint8  * const pbD, const uint8  * const pbA );

void vmp_prol1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_prol1HMMI(     uint16 * const phD, const uint16 * const phA );
void vmp_prol1HMMI0(    uint16 * const phD, const uint16 * const phA );

void vmp_prol1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WMMI(     uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WMMI0(    uint32 * const pwD, const uint32 * const pwA );


#ifdef __cplusplus
}
#endif

#endif  //__PRotEx_H





