
//
//  PRotMIPS.c - Packed Rotation 
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 2 Jun 98 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <stdio.h>

#ifdef CC_VMP_PS2
#ifndef HOMEBREW
#include    <libvu0.h>
#endif
#endif

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "vmp3D.h"
#include "vmp3DEx.h"
#include "PRot.h"
#include "PRotEx.h"



//
//  Setup Vec3D module
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void PRotSetup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR4(pcinfo);
        
    vmp_psraB =             vmp_psraBMMI;
    vmp_psraB0 =            vmp_psraBMMI0;
    vmp_psraH =             vmp_psraHMMI;
    vmp_psraH0 =            vmp_psraHMMI0;
    vmp_psraW =             vmp_psraWMMI;
    vmp_psraW0 =            vmp_psraWMMI0;

    vmp_psra1B =            vmp_psra1BMMI;
    vmp_psra1B0 =           vmp_psra1BMMI0;
    vmp_psra1H =            vmp_psra1HMMI;
    vmp_psra1H0 =           vmp_psra1HMMI0;
    vmp_psra1W =            vmp_psra1WMMI;
    vmp_psra1W0 =           vmp_psra1WMMI0;

    vmp_psllB =             vmp_psllBMMI;
    vmp_psllB0 =            vmp_psllBMMI0;
    vmp_psllH =             vmp_psllHMMI;
    vmp_psllH0 =            vmp_psllHMMI0;
    vmp_psllW =             vmp_psllWMMI;
    vmp_psllW0 =            vmp_psllWMMI0;

    vmp_psll1B =            vmp_psll1BMMI;
    vmp_psll1B0 =           vmp_psll1BMMI0;
    vmp_psll1H =            vmp_psll1HMMI;
    vmp_psll1H0 =           vmp_psll1HMMI0;
    vmp_psll1W =            vmp_psll1WMMI;
    vmp_psll1W0 =           vmp_psll1WMMI0;

    vmp_psrlB =             vmp_psrlBMMI;
    vmp_psrlB0 =            vmp_psrlBMMI0;
    vmp_psrlH =             vmp_psrlHMMI;
    vmp_psrlH0 =            vmp_psrlHMMI0;
    vmp_psrlW =             vmp_psrlWMMI;
    vmp_psrlW0 =            vmp_psrlWMMI0;

    vmp_psrl1B =            vmp_psrl1BMMI;
    vmp_psrl1B0 =           vmp_psrl1BMMI0;
    vmp_psrl1H =            vmp_psrl1HMMI;
    vmp_psrl1H0 =           vmp_psrl1HMMI0;
    vmp_psrl1W =            vmp_psrl1WMMI;
    vmp_psrl1W0 =           vmp_psrl1WMMI0;

    vmp_prolB =             vmp_prolBMMI;
    vmp_prolB0 =            vmp_prolBMMI0;
    vmp_prolH =             vmp_prolHMMI;
    vmp_prolH0 =            vmp_prolHMMI0;
    vmp_prolW =             vmp_prolWMMI;
    vmp_prolW0 =            vmp_prolWMMI0;

    vmp_prol1B =            vmp_prol1BMMI;
    vmp_prol1B0 =           vmp_prol1BMMI0;
    vmp_prol1H =            vmp_prol1HMMI;
    vmp_prol1H0 =           vmp_prol1HMMI0;
    vmp_prol1W =            vmp_prol1WMMI;
    vmp_prol1W0 =           vmp_prol1WMMI0;
}




