
//
//  PasEx.h - Packed Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This module is designed for fast 3D math
//
//  Created - 31 Dec, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PasEx_H
#define __PasEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PasSetup( const CpuInfo * const pcinfo );

    //  Addition (Un)signed

void vmp_paddBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddBMMI(       uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddBMMI0(      uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_paddHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddHMMI(       uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddHMMI0(      uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

void vmp_paddWGeneric(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_paddWMMI(       uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_paddWMMI0(      uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );

    //  Subtraction (Un)signed

void vmp_psubBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubBMMI(       uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubBMMI0(      uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_psubHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubHMMI(       uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubHMMI0(      uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

void vmp_psubWGeneric(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_psubWMMI(       uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_psubWMMI0(      uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );

    //  Addition signed Saturation

void vmp_paddsBGeneric( int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_paddsBMMI(      int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_paddsBMMI0(     int8  * const pbD, const int8  * const pbA, const int8  * const pbB );

void vmp_paddsHGeneric( int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_paddsHMMI(      int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_paddsHMMI0(     int16 * const phD, const int16 * const phA, const int16 * const phB );

    //  Subtraction signed Saturation

void vmp_psubsBGeneric( int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_psubsBMMI(      int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_psubsBMMI0(     int8  * const pbD, const int8  * const pbA, const int8  * const pbB );

void vmp_psubsHGeneric( int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_psubsHMMI(      int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_psubsHMMI0(     int16 * const phD, const int16 * const phA, const int16 * const phB );

    //  Addition Unsigned Saturation

void vmp_paddusBGeneric( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddusBMMI(      uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddusBMMI0(     uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_paddusHGeneric( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddusHMMI(      uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddusHMMI0(     uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

    //  Subtraction Unsigned Saturation

void vmp_psubusBGeneric( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubusBMMI(      uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubusBMMI0(     uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_psubusHGeneric( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubusHMMI(      uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubusHMMI0(     uint16 * const phD, const uint16 * const phA, const uint16 * const phB );



#ifdef __cplusplus
}
#endif

#endif  //__PasEx_H





