
//
//  PasMIPS.c - Packed Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 31 Dec 2001 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <stdio.h>

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "Pas.h"
#include "PasEx.h"



//
//  Setup Packed Addition/Subtraction
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void PasSetup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR4(pcinfo);
        
    vmp_paddB =             vmp_paddBMMI;
    vmp_paddB0 =            vmp_paddBMMI0;
    vmp_paddH =             vmp_paddHMMI;
    vmp_paddH0 =            vmp_paddHMMI0;
    vmp_paddW =             vmp_paddWMMI;
    vmp_paddW0 =            vmp_paddWMMI0;

    vmp_psubB =             vmp_psubBMMI;
    vmp_psubB0 =            vmp_psubBMMI0;
    vmp_psubH =             vmp_psubHMMI;
    vmp_psubH0 =            vmp_psubHMMI0;
    vmp_psubW =             vmp_psubWMMI;
    vmp_psubW0 =            vmp_psubWMMI0;

    vmp_paddusB =           vmp_paddusBMMI;
    vmp_paddusB0 =          vmp_paddusBMMI0;
    vmp_paddusH =           vmp_paddusHMMI;
    vmp_paddusH0 =          vmp_paddusHMMI0;

    vmp_psubusB =           vmp_psubusBMMI;
    vmp_psubusB0 =          vmp_psubusBMMI0;
    vmp_psubusH =           vmp_psubusHMMI;
    vmp_psubusH0 =          vmp_psubusHMMI0;

    vmp_paddsB =            vmp_paddsBMMI;
    vmp_paddsB0 =           vmp_paddsBMMI0;
    vmp_paddsH =            vmp_paddsHMMI;
    vmp_paddsH0 =           vmp_paddsHMMI0;

    vmp_psubsB =            vmp_psubsBMMI;
    vmp_psubsB0 =           vmp_psubsBMMI0;
    vmp_psubsH =            vmp_psubsHMMI;
    vmp_psubsH0 =           vmp_psubsHMMI0;
}




