  
//
//  QVas3DEx.h - 3D (Quad Vector) Math Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include    "CpuAsm.h"


#ifndef __QVas3DEx_H
#define __QVas3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVas3DSetup( const CpuInfo * const pcinfo );

void vmp_QVecAddGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecAddVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecAddVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QVecAddScalarGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecAddScalarVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecAddScalarVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

void vmp_QVecSubGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecSubVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecSubVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QVecSubScalarGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecSubScalarVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecSubScalarVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);



#ifdef __cplusplus
}
#endif

#endif  //__QVas3DEx_H


