
//
//  QVas3DMips.s - Packed (128bit MIPS) Quad Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Jul, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//

    .nolist
#include "Mips.inc"
#include "KariType.inc"
    .list

    .set    noreorder
    .set    nomips16

    .section .text                                                    


//_________________________________________________________________________________________________
//=================================================================================================
//  (Quad) Vector Summation (Addition)  (MIPS V)
//
//  void vmp_QVecAdd(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB)
//

    .align 3
    .global vmp_QVecAddMIPSV
vmp_QVecAddMIPSV:

ASSERT_PTR16(a1)
ASSERT_PTR16(a2)
ASSERT_PTR16(a0)

    ldc1   $f4, 0(a1)     ; {A1 A0} Mem to PS_SPFP
    ldc1   $f6, 0(a2)     ; {B1 B0}
    ldc1   $f5, 8(a1)     ; {A3 A2}
    ldc1   $f7, 8(a2)     ; {B3 B2}

    add.ps $f4, $f4, $f6  ; {A1+B1 A0+B0}
    add.ps $f5, $f5, $f7  ; {A3+B3 A2+B2}

    sdc1   $f4, 0(a0)     ; {D1 D0}
    sdc1   $f5, 8(a0)     ; {D3 D2}

    j       ra              // ret
    BDELAY                  // nop = Branch Delay Slot



