
//
//  Vas3DMips.s - Packed (128bit MIPS) Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Jul, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//

    .nolist
#include "Mips.inc"
#include "KariType.inc"
    .list

    .set    noreorder
    .set    nomips16

    .section .text                                                    


//_________________________________________________________________________________________________
//=================================================================================================
//  Vector Summation (Addition)  (MIPS V)
//
//  void vmp_VecAdd(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB)
//

    .align 3
    .global vmp_VecAddMIPSV
vmp_VecAddMIPSV:

ASSERT_PTR16(a1)
ASSERT_PTR16(a2)
ASSERT_PTR16(a0)

    ldc1   $f4, 0(a1)     ; {A1 A0} Mem to PS_FP
    ldc1   $f6, 0(a2)     ; {B1 B0}
    lwc1   $f5, 8(a1)     ; {   A2}
    lwc1   $f7, 8(a2)     ; {   B2}

    add.ps $f4, $f4, $f6  ; {A1+B1 A0+B0}
    add.s  $f5, $f5, $f7  ; {      A2+B2}

    sdc1   $f4, 0(a0)     ; {D1 D0}
    swc1   $f5, 8(a0)     ; {   D2}

    j       ra              // ret
    BDELAY                  // nop = Branch Delay Slot



