  
//
//  Pmd.h - Packed Multiplication/Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 31 Dec 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions


#ifndef __Pmd_H
#define __Pmd_H

#ifdef __cplusplus
extern "C" {
#endif


    //  Multiplication Highs & lows
typedef void (*vmp_pmulhBProc)( int8 * const pbD, const int8 * const pbA, const int8 * const pbB );
extern vmp_pmulhBProc vmp_pmulhB;
extern vmp_pmulhBProc vmp_pmulhB0;

typedef void (*vmp_pmulhuBProc)( uint8 * const pbD, const uint8 * const pbA, const uint8 * const pbB );
extern vmp_pmulhuBProc vmp_pmulhuB;
extern vmp_pmulhuBProc vmp_pmulhuB0;

typedef void (*vmp_pmulluBProc)( uint8 * const pbD, const uint8 * const pbA, const uint8 * const pbB );
extern vmp_pmulluBProc vmp_pmulluB;
extern vmp_pmulluBProc vmp_pmulluB0;
#define vmp_pmullB(d,a,b) vmp_pmulluB((uint8*)d, (uint8*)a, (uint8*)b)
#define vmp_pmullB0(d,a,b) vmp_pmulluB0((uint8*)d, (uint8*)a, (uint8*)b)


typedef void (*vmp_pmulhHProc)( int16 * const phD, const int16 * const phA, const int16 * const phB );
extern vmp_pmulhHProc vmp_pmulhH;
extern vmp_pmulhHProc vmp_pmulhH0;

typedef void (*vmp_pmulhuHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_pmulhuHProc vmp_pmulhuH;
extern vmp_pmulhuHProc vmp_pmulhuH0;

typedef void (*vmp_pmulluHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_pmulluHProc vmp_pmulluH;
extern vmp_pmulluHProc vmp_pmulluH0;
#define vmp_pmullH(d,a,b) vmp_pmulluH((uint16*)d, (uint16*)a, (uint16*)b)
#define vmp_pmullH0(d,a,b) vmp_pmulluH0((uint16*)d, (uint16*)a, (uint16*)b)


typedef void (*vmp_pmulluWProc)( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
extern vmp_pmulluWProc vmp_pmulluW;
extern vmp_pmulluWProc vmp_pmulluW0;

#define vmp_pmullW(d,a,b) vmp_pmulluW((uint32*)d, (uint32*)a, (uint32*)b)
#define vmp_pmullW0(d,a,b) vmp_pmulluW0((uint32*)d, (uint32*)a, (uint32*)b)

    //  Multiplication Hi/Lo

typedef void (*vmp_pmulhlBProc)( int8 * const pbHi, int8 * const pbLo, const int8 * const pbA, const int8 * const pbB );
extern vmp_pmulhlBProc vmp_pmulhlB;
extern vmp_pmulhlBProc vmp_pmulhlB0;

typedef void (*vmp_pmulhluBProc)( uint8 * const pbHi, uint8 * const pbLo, const uint8 * const pbA, const uint8 * const pbB );
extern vmp_pmulhluBProc vmp_pmulhluB;
extern vmp_pmulhluBProc vmp_pmulhluB0;

typedef void (*vmp_pmulhlHProc)( int16 * const phHi, int16 * const phLo, const int16 * const phA, const int16 * const phB );
extern vmp_pmulhlHProc vmp_pmulhlH;
extern vmp_pmulhlHProc vmp_pmulhlH0;

typedef void (*vmp_pmulhluHProc)( uint16 * const phHi, uint16 * const phLo, const uint16 * const phA, const uint16 * const phB );
extern vmp_pmulhluHProc vmp_pmulhluH;
extern vmp_pmulhluHProc vmp_pmulhluH0;

    //  Multiplication Odd/Even

typedef void (*vmp_pmullueBProc)( uint16 * const phD, const uint8 * const pbA, const uint8 * const pbB );
extern vmp_pmullueBProc vmp_pmullueB;
extern vmp_pmullueBProc vmp_pmullueB0;

typedef void (*vmp_pmulluoBProc)( uint16 * const phD, const uint8 * const pbA, const uint8 * const pbB );
extern vmp_pmulluoBProc vmp_pmulluoB;
extern vmp_pmulluoBProc vmp_pmulluoB0;

typedef void (*vmp_pmulleBProc)( int16 * const phD, const int8 * const pbA, const int8 * const pbB );
extern vmp_pmulleBProc vmp_pmulleB;
extern vmp_pmulleBProc vmp_pmulleB0;

typedef void (*vmp_pmulloBProc)( int16 * const phD, const int8 * const pbA, const int8 * const pbB );
extern vmp_pmulloBProc vmp_pmulloB;
extern vmp_pmulloBProc vmp_pmulloB0;

typedef void (*vmp_pmullueHProc)( uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
extern vmp_pmullueHProc vmp_pmullueH;
extern vmp_pmullueHProc vmp_pmullueH0;

typedef void (*vmp_pmulluoHProc)( uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
extern vmp_pmulluoHProc vmp_pmulluoH;
extern vmp_pmulluoHProc vmp_pmulluoH0;

typedef void (*vmp_pmulleHProc)( int32 * const pwD, const int16 * const phA, const int16 * const phB );
extern vmp_pmulleHProc vmp_pmulleH;
extern vmp_pmulleHProc vmp_pmulleH0;

typedef void (*vmp_pmulloHProc)( int32 * const pwD, const int16 * const phA, const int16 * const phB );
extern vmp_pmulloHProc vmp_pmulloH;
extern vmp_pmulloHProc vmp_pmulloH0;



#ifdef __cplusplus
}
#endif

#endif  //__Pmd_H


