
//
//  PmdMIPS.c - Packed Multiplication/Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 18 Feb 2002 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <stdio.h>

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "Pmd.h"
#include "PmdEx.h"



//
//  Setup Packed Multiplication/Division
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void PmdSetup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR4(pcinfo);
        
    vmp_pmulhH =            vmp_pmulhHMMI;
    vmp_pmulhH0 =           vmp_pmulhHMMI0;
    vmp_pmulhuH =           vmp_pmulhuHMMI;
    vmp_pmulhuH0 =          vmp_pmulhuHMMI0;
    vmp_pmulluH =           vmp_pmulluHMMI;
    vmp_pmulluH0 =          vmp_pmulluHMMI0;

    //  Multiplication Hi/Lo

    vmp_pmulhlH =           vmp_pmulhlHMMI;
    vmp_pmulhlH0 =          vmp_pmulhlHMMI0;
    vmp_pmulhluH =          vmp_pmulhluHMMI;
    vmp_pmulhluH0 =         vmp_pmulhluHMMI0;

    //  Multiplication Odd/Even

    vmp_pmullueH =          vmp_pmullueHMMI;
    vmp_pmullueH0 =         vmp_pmullueHMMI0;
    vmp_pmulluoH =          vmp_pmulluoHMMI;
    vmp_pmulluoH0 =         vmp_pmulluoHMMI0;
    vmp_pmulleH =           vmp_pmulleHMMI;
    vmp_pmulleH0 =          vmp_pmulleHMMI0;
    vmp_pmulloH =           vmp_pmulloHMMI;
    vmp_pmulloH0 =          vmp_pmulloHMMI0;

    vmp_pmulhB =            vmp_pmulhBMMI;
    vmp_pmulhB0 =           vmp_pmulhBMMI0;
    vmp_pmulhuB =           vmp_pmulhuBMMI;
    vmp_pmulhuB0 =          vmp_pmulhuBMMI0;
    vmp_pmulluB =           vmp_pmulluBMMI; 
    vmp_pmulluB0 =          vmp_pmulluBMMI0;

    vmp_pmulluW =           vmp_pmulluWMMI;
    vmp_pmulluW0 =          vmp_pmulluWMMI0;

    //  Multiplication Hi/Lo

    vmp_pmulhlB =           vmp_pmulhlBMMI;
    vmp_pmulhlB0 =          vmp_pmulhlBMMI0;
    vmp_pmulhluB =          vmp_pmulhluBMMI;
    vmp_pmulhluB0 =         vmp_pmulhluBMMI0;

    //  Multiplication Odd/Even

    vmp_pmullueB =          vmp_pmullueBMMI;
    vmp_pmullueB0 =         vmp_pmullueBMMI0;
    vmp_pmulluoB =          vmp_pmulluoBMMI;
    vmp_pmulluoB0 =         vmp_pmulluoBMMI0;
    vmp_pmulleB =           vmp_pmulleBMMI;
    vmp_pmulleB0 =          vmp_pmulleBMMI0;
    vmp_pmulloB =           vmp_pmulloBMMI;
    vmp_pmulloB0 =          vmp_pmulloBMMI0;

}




