  
//
//  QVmd3DEx.h - (Quad) 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "CpuAsm.h"
#include    "vmp3D.h"


#ifndef __QVmd3DEx_H
#define __QVmd3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVmd3DSetup( const CpuInfo * const pcinfo );

void vmp_QVecMulGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QVecScaleGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );
void vmp_QVecScaleVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );
void vmp_QVecScaleVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );

void vmp_QVecMAddGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddVU(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecMSubGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubVU(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecDivGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

//void vmp_QVecDivFastVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
//void vmp_QVecDivFastVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

void vmp_QDotProductGeneric(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductVU(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductVU0(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QCrossProductGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductVU( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductVU0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);


#ifdef __cplusplus
}
#endif

#endif  //__QVmd3DEx_H


