  
//
//  Vmd3DEx.h - 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "CpuAsm.h"
#include    "vmp3D.h"


#ifndef __Vmd3DEx_H
#define __Vmd3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vmd3DSetup( const CpuInfo * const pcinfo );

void vmp_VecMulGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecMulVU( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecMulVU0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);

void vmp_VecScaleGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecScaleVU( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecScaleVU0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );

void vmp_VecMAddGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMAddVU(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMAddVU0(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);

void vmp_VecMSubGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMSubVU(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMSubVU0(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);

void vmp_VecDivGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivVU( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivVU0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );

//void vmp_VecDivFastVU( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
//void vmp_VecDivFastVU0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );

void vmp_DotProductGeneric( float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
void vmp_DotProductVU( float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
void vmp_DotProductVU0( float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);

void vmp_CrossProductGeneric( vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);
void vmp_CrossProductVU( vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);
void vmp_CrossProductVU0( vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);


#ifdef __cplusplus
}
#endif

#endif  //__Vmd3DEx_H


