
//
//  QVsf3DMips.s - Packed (128bit MIPS) Quad Special Functions
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Jul, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//

    .nolist
#include "Mips.inc"
#include "KariType.inc"
    .list

    .set    noreorder
    .set    nomips16

    .section .text                                                    


//_________________________________________________________________________________________________
//=================================================================================================
//  (Quad) Vector Square Root (MIPS-3D)
//
//  void vmp_QVecSqrt(vmp3DQVector * const pvD, const vmp3DQVector * const pvA)
//

    .align 3
    .global vmp_QVecSqrtFastMIPS3D
vmp_QVecSqrtFastMIPS3D:

ASSERT_PTR16(a1)
ASSERT_PTR16(a0)
//  ASSERT_FNEG( a1.x .y .z .w )

    ldc1      $f4, 0(a1)     // {Ay Ax}
    ldc1      $f5, 8(a1)     // {Aw Az}

    rsqrt1.ps $f6, $f4      // {1/sqrt(Ay) 1/sqrt(Ax)}
    rsqrt1.ps $f7, $f5      // {1/sqrt(Aw) 1/sqrt(Az)}

    mul.ps    $f4, $f4, $f6  // {Ay*1/sqrt(Ay) Ax*1/sqrt(Ax)}
    mul.ps    $f5, $f5, $f7  // {Aw*1/sqrt(Aw) Az*1/sqrt(Az)}

    sdc1      $f4, 0(a0)     // {Dy Dx}
    sdc1      $f5, 8(a0)     // {Dw Dz}

    j       ra              // ret
    BDELAY                  // nop = Branch Delay Slot



    .align 3
    .global vmp_QVecSqrtMIPS3D
vmp_QVecSqrtMIPS3D:

ASSERT_PTR16(a1)
ASSERT_PTR16(a0)
//  ASSERT_FNEG( a1.x .y .z .w )

    ldc1      $f4, 0(a1)     // {Ay Ax}
    ldc1      $f5, 8(a1)     // {Aw Az}

    rsqrt1.ps $f6, $f4      // {1/sqrt(Ay) 1/sqrt(Ax)}
    rsqrt1.ps $f7, $f5      // {1/sqrt(Aw) 1/sqrt(Az)}

    rsqrt2.ps $f8, $f6, $f4
    rsqrt2.ps $f9, $f7, $f5

    madd.s    $f10, $f6, $f6, $f8 // 24bit {1/sqrt(Ay) 1/sqrt(Ax)}
    madd.s    $f11, $f7, $f7, $f9 // 24bit {1/sqrt(Aw) 1/sqrt(Az)}

    mul.ps    $f4, $f4, $f10 // {Ay*1/sqrt(Ay) Ax*1/sqrt(Ax)}
    mul.ps    $f5, $f5, $f11 // {Aw*1/sqrt(Aw) Az*1/sqrt(Az)}

    sdc1      $f4, 0(a0)     // {Dy Dx}
    sdc1      $f5, 8(a0)     // {Dw Dz}

    j       ra              // ret
    BDELAY                  // nop = Branch Delay Slot





