  
//
//  Vsf3DEx.h - 3D Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include    "CpuAsm.h"



#ifndef __Vsf3DEx_H
#define __Vsf3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vsf3DSetup( const CpuInfo * const pcinfo );


void vmp_VecSqrtGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtVU(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtFastVU(vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecMinGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMinVU(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMaxGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMaxVU(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMagnitudeGeneric(float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeVU(float * const pfD, const vmp3DVector * const pvA);

void vmp_VecMagnitudeFastVU(float * const pfD, const vmp3DVector * const pvA);

void vmp_VecNormalizeGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeVU(vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecNormalizeFastVU(vmp3DVector * const pvD, const vmp3DVector * const pvA);



#ifdef __cplusplus
}
#endif

#endif  //__Vsf3DEx_H


