
//
//  VTrig3D.c - 3D Vector Trignometric Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <stdio.h>
#include    <math.h>

    //  Book Development Library Modules

#include    "vmp3D.h"
#include    "vmp3DEx.h"
#include    "VTrig3D.h"                                 // 3D Math
#include    "VTrig3DEx.h"



vmp_FSinCosProc         vmp_FSinCos;
vmp_FSinProc            vmp_FSin;
vmp_FCosProc            vmp_FCos;
vmp_FTanProc            vmp_FTan;





void vmp_FSinCosGeneric( float * const pfSin, float * const pfCos, float fRads )
{
    ASSERT_PTR( pfSin );
    ASSERT_PTR( pfCos );

    *pfCos = cosf( fRads );
    *pfSin = sinf( fRads );
}


void vmp_FSinGeneric( float * const pfD, float fRads )
{
    ASSERT_PTR( pfD );

    *pfD = sinf( fRads );
}


void vmp_FCosGeneric( float * const pfD, float fRads )
{
    ASSERT_PTR( pfD );

    *pfD = cosf( fRads );
}


void vmp_FTanGeneric( float * const pfD, float fRads )
{
    ASSERT_PTR( pfD );

    *pfD = tanf( fRads );
}




