  
//
//  VTrig3DEx.h - 3D Math Trignometric Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include    "CpuAsm.h"
#include    "vmp3D.h"


#ifndef __VTrig3DEx_H
#define __VTrig3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void VTrig3DSetup( const CpuInfo * const pcinfo );


void vmp_FSinCosGeneric(float * const pfSin, float * const pfCos, float fRads );
void vmp_FSinCosVU(     float * const pfSin, float * const pfCos, float fRads );

void vmp_FSinGeneric(float * const pfD, float fRads );
void vmp_FSinVU(     float * const pfD, float fRads );

void vmp_FCosGeneric(float * const pfD, float fRads );
void vmp_FCosVU(     float * const pfD, float fRads );

void vmp_FTanGeneric(float * const pfD, float fRads );
void vmp_FTanVU(     float * const pfD, float fRads );



#ifdef __cplusplus
}
#endif

#endif  //__VTrig3DEx_H


