
//
//  MCompEx.h - Motion Compensation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//		This module is designed for fast 3D math
//
//  Created - 21 Feb, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __MCompEx_H
#define __MCompEx_H

#ifdef __cplusplus
extern "C" {
#endif


void MCompSetup( const CpuInfo * const pcinfo );

	//	Horizontal 8x8 Motion Compensation w/Rounding

void vmp_MCompHz8RGenericSLOW( uint8 * pbDst, const uint8 * pbSrc, int iStride );

void vmp_MCompHz8RGeneric( uint8 * pbDst, const uint8 * pbSrc, int iStride );
void vmp_MCompHz8RMMI(     uint8 * pbDst, const uint8 * pbSrc, int iStride );

	//	Horizontal 16x16 Motion Compensation w/Rounding

void vmp_MCompHz16RGenericSLOW( uint8 * pbDst, const uint8 * pbSrc, int iStride );

void vmp_MCompHz16RGeneric( uint8 * pbDst, const uint8 * pbSrc, int iStride );
void vmp_MCompHz16RMMI(     uint8 * pbDst, const uint8 * pbSrc, int iStride );


	//	Vertical 8x8 Motion Compensation w/Rounding

void vmp_MCompVt8RGenericSLOW( uint8 * pbDst, const uint8 * pbSrc, int iStride );

void vmp_MCompVt8RGeneric( uint8 * pbDst, const uint8 * pbSrc, int iStride );
void vmp_MCompVt8RMMI(     uint8 * pbDst, const uint8 * pbSrc, int iStride );

	//	Vertical 16x16 Motion Compensation w/Rounding

void vmp_MCompVt16RGenericSLOW( uint8 * pbDst, const uint8 * pbSrc, int iStride );

void vmp_MCompVt16RGeneric( uint8 * pbDst, const uint8 * pbSrc, int iStride );
void vmp_MCompVt16RMMI(     uint8 * pbDst, const uint8 * pbSrc, int iStride );





#ifdef __cplusplus
}
#endif

#endif  //__MCompEx_H





