
//
//  MCompMIPX.c - Motion Compensation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 21 Feb, 2002 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

	//	3rd Party Libraries
	
#include	<assert.h>
#include	<stdio.h>

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "vmp3D.h"
#include "vmp3DEx.h"
#include "MComp.h"
#include "MCompEx.h"



//
//	Setup Motion Compensation
//
//	NOTE: This function sets up the function vectors so the best function
//		is attached to the vector for the processor running.
//

void MCompSetup( const CpuInfo * const pcinfo )
{
	ASSERT_PTR(pcinfo);
	    
	vmp_MCompHz8R =			vmp_MCompHz8RMMI;
	vmp_MCompHz16R = 		vmp_MCompHz16RMMI;
	vmp_MCompVt8R =			vmp_MCompVt8RMMI;
	vmp_MCompVt16R = 		vmp_MCompVt16RMMI;
}




