
//
//  CpuAsm.h - Cpu Detection - 
//
//  Cpu - EE - VU# Cpu definitions
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//  Created - 24 Nov 2001 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions



#ifndef __CpuAsm_H
#define __CpuAsm_H

#ifdef __cplusplus
extern "C" {
#endif



//
//  CPU definition Id's
//

typedef enum
{
    CPU_PS2     =   2           // PS2
} CPU;



//
//  CPU bit flags
//

typedef enum
{
    CPUBITS_EE          =   0x00000001,                 // Emotion Engine
    CPUBITS_VU0         =   0x00000002,                 // VPU0
    CPUBITS_VU1         =   0x00000004                  // VPU1
} CPUBITS;



//
//  CPU Vendors
//

typedef enum
{
    CPUVEN_UNKNOWN      =   0,                          // Unknown
    CPUVEN_TOSHIBA      =   1,                          // Motorola
} CPUVEN;


//
//  Cpu Information
//

typedef struct CpuInfoType
{
    uint    nCpuId;                                     // Cpu type Identifier
    uint    nFpuId;                                     // Floating Point Unit Identifier
    uint    nBits;                                      // Feature Bits
    uint    nMfg;                                       // Manufacturer
} CpuInfo;



    //
    //  Function Prototypes
    //

void CpuDetect( CpuInfo * const pInfo );

#define CPU_SZBUF_MAX   (80+100)
char *CpuInfoStr( char *pszBuf, const CpuInfo * const pInfo );


#ifdef __cplusplus
}
#endif

#endif  //__CpuAsm_H

