
//
// Mips.h
//
// This document contains file that you may use at your own risk in your own programs.
//
// This module is designed to work with the exercises for this book.
//
//   Created - 24 Jan, 2002 - J.Leiterman
//
//   Modifications
//
//
//  Tabs = 4
//

#ifndef MIPS_H
#define MIPS_H


#define zero    $0          // Zero Value - Constant

#define at      $1          // Assembler reserved

#define v0      $2
#define v1      $3

#define a0      $4              // Function arguments (0,1,2,3)
#define a1      $5
#define a2      $6
#define a3      $7

#define t0      $8              // (scratch) temporary registers
#define t1      $9
#define t2      $10
#define t3      $11
#define t4      $12
#define t5      $13
#define t6      $14
#define t7      $15
#define t8      $24
#define t9      $25

#define s0      $16             // Subroutine register variables
#define s1      $17             // (leave intact for function return)
#define s2      $18
#define s3      $19
#define s4      $20
#define s5      $21
#define s6      $22
#define s7      $23
                    // WARNING: Used for Stack Frame AND 9th register variable!
#define s8      $30             // Ninth register variable

#define k0      $26             // Interrupt/Trap Handler
#define k1      $27

#define gp      $28     //$gp   // Global Pointer
#define sp      $29     //$sp   // Stack Pointer

#define fp      $30             // (Frame Pointer) sEE: S8

#define ra      $31             // Subroutine Return address 


#define pc      $pc             // Program Counter


//
//  Instruction Insertion
//

//  NOTE: If R4000 and above MOP not needed!
#define LDELAY  //nop               // Load Slot Delay

#define BDELAY  nop             // Branch Slot Delay


#endif // MIPS_H

